package eu.mhsl.craftattack.worldmuseum;

import eu.mhsl.craftattack.worldmuseum.worlds.World;
import net.minestom.server.coordinate.Point;
import net.minestom.server.coordinate.Pos;
import net.minestom.server.entity.Player;
import net.minestom.server.network.player.PlayerConnection;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.time.Duration;
import java.util.UUID;
import java.util.concurrent.CompletableFuture;

public class NewPlayer extends Player {
    private boolean allowMovemenrt = true;
    private long lastCompassUsage = System.currentTimeMillis();

    public NewPlayer(@NotNull UUID uuid, @NotNull String username, @NotNull PlayerConnection playerConnection) {
        super(uuid, username, playerConnection);

    }
    public void setSyncCooldown(@Nullable Duration cooldown) {
        this.setCustomSynchronizationCooldown(cooldown);
    }

    public boolean isAllowMovement() {
        return allowMovemenrt;
    }
    public void update_lastCompassUsage() {
        lastCompassUsage = System.currentTimeMillis();
    }
    public boolean isAllowCompassUsage() {
        long UsageDifference = System.currentTimeMillis() - lastCompassUsage;
        System.out.println(UsageDifference);
        long DIFFERENCE = 10000; //in Milisec
        if (UsageDifference >= DIFFERENCE) return true;
        return false;
    }

    public void setAllowMovement(boolean allowMovemenrt) {
        this.allowMovemenrt = allowMovemenrt;
    }



    public void newTeleport(Point point) {
        this.allowMovemenrt = false;
        World world =  (World) this.getInstance();
        CompletableFuture.runAsync(
                () -> world.loadOptionalChunk(point)
                .thenRun(() -> this.teleport(new Pos(point))));


    }
}
