package eu.mhsl.craftattack.worldmuseum.listener;

import eu.mhsl.craftattack.worldmuseum.NewPlayer;
import eu.mhsl.craftattack.worldmuseum.items.CompassManager;
import net.minestom.server.entity.Player;
import net.minestom.server.event.player.PlayerUseItemEvent;
import net.minestom.server.item.ItemStack;
import java.util.function.Consumer;

public class ItemUseListener implements Consumer<PlayerUseItemEvent> {

    @Override
    public void accept(PlayerUseItemEvent playerUseItemEvent) {
        NewPlayer p = (NewPlayer) playerUseItemEvent.getPlayer();
        ItemStack usedItem = playerUseItemEvent.getItemStack();
        CompassManager compassManager = CompassManager.getInstance();

        if (!usedItem.equals(compassManager.getCompass())) return;
        if (!p.isAllowCompassUsage()) return;
        p.update_lastCompassUsage();
        p.openInventory(compassManager.getInventory());
        playerUseItemEvent.setCancelled(true);
    }
}
