package eu.mhsl.craftattack.worldmuseum.util;

import eu.mhsl.craftattack.worldmuseum.NewPlayer;
import eu.mhsl.craftattack.worldmuseum.worlds.World;
import net.minestom.server.potion.Potion;
import net.minestom.server.potion.PotionEffect;
import net.minestom.server.thread.MinestomThread;

public class ChangeWorld extends MinestomThread {
    public ChangeWorld(NewPlayer player, World targetWorld) {
        super("load_world_for_player");
        player.setAllowMovement(false);
        player.addEffect(new Potion(PotionEffect.BLINDNESS, (byte) 0, 1000000));

        player.setRespawnPoint(targetWorld.getSpawn());
        player.setInstance(targetWorld, targetWorld.getSpawn()).thenRun(() -> {
            player.setAllowMovement(true);
            player.clearEffects();
            player.update_lastCompassUsage();
        });
    }
}
